<?php

namespace App\Http\Livewire;

use Livewire\Component;
use Illuminate\Support\Facades\Auth;
use App\Http\Middleware\TenantMiddleware;
class Discipline extends Component
{
    public $records, $name, $enabled, $dataId, $update = false, $add = false;

    protected $rules = [
        'name' => 'required'
    ];

    protected $messages = [
        'name.required' => 'Il nome è obbligatorio'
    ];

    public $sortField ='name';
    public $sortAsc = true;
    public function boot()
    {
        app(TenantMiddleware::class)->setupTenantConnection();
    }

    public function mount(){

        if(Auth::user()->level != env('LEVEL_ADMIN', 0))
            return redirect()->to('/dashboard');

    }

    public function sortBy($field)
    {
        if($this->sortField === $field)
        {
            $this->sortAsc = ! $this->sortAsc;
        } else {
            $this->sortAsc = true;
        }

        $this->sortField = $field;
    }

    public function resetFields(){
        $this->name = '';
        $this->enabled = true;
        $this->emit('load-data-table');
    }

    public function render()
    {
        $this->records = \App\Models\Discipline::select('id', 'name', 'enabled')->get();
        return view('livewire.discipline');
    }

    public function add()
    {
        $this->resetFields();
        $this->add = true;
        $this->update = false;
    }

    public function store()
    {
        $this->validate();
        try {
            \App\Models\Discipline::create([
                'name' => $this->name,
                'enabled' => $this->enabled
            ]);
            session()->flash('success','Disciplina creata');
            $this->resetFields();
            $this->add = false;
        } catch (\Exception $ex) {
            session()->flash('error','Errore (' . $ex->getMessage() . ')');
        }
    }

    public function edit($id){
        try {
            $discipline = \App\Models\Discipline::findOrFail($id);
            if( !$discipline) {
                session()->flash('error','disciplina non trovata');
            } else {
                $this->name = $discipline->name;
                $this->enabled = $discipline->enabled;
                $this->dataId = $discipline->id;
                $this->update = true;
                $this->add = false;
            }
        } catch (\Exception $ex) {
            session()->flash('error','Errore (' . $ex->getMessage() . ')');
        }
    }

    public function update()
    {
        $this->validate();
        try {
            \App\Models\Discipline::whereId($this->dataId)->update([
                'name' => $this->name,
                'enabled' => $this->enabled
            ]);
            session()->flash('success','Disciplina aggiornata');
            $this->resetFields();
            $this->update = false;
        } catch (\Exception $ex) {
            session()->flash('error','Errore (' . $ex->getMessage() . ')');
        }
    }

    public function cancel()
    {
        $this->add = false;
        $this->update = false;
        $this->resetFields();
    }

    public function delete($id)
    {
        try{
            \App\Models\discipline::find($id)->delete();
            session()->flash('success',"Disciplina eliminata");
            return redirect(request()->header('Referer'));
        }catch(\Exception $e){
            session()->flash('error','Errore (' . $e->getMessage() . ')');
        }
    }
}
